
BASE_GEMS       = {"rubygems-update"=>"2.7.6", "xml-simple"=>"1.1.2", "httpclient"=>"2.6.0.1", "multipart-post"=>"2.0.0", "faraday"=>"0.9.0", "mime-types"=>"2.0"}
CORE_GEMS       = %w(rally_api rallyeif-wrk)
PROD_GEMS       = %w(rally_jest ClothRed rallyeif-jira)

if !ENV.has_key?('GEM_COMMAND')
   puts "You must set an environment var named GEM_COMMAND with the path to your Ruby 'gem' command"
   puts "Example: export GEM_COMMAND=/usr/bin/rubies/ruby-2.2.6/bin/gem    #(for Linux/Mac)"
   puts "Example: set GEM_COMMAND=C:\Ruby226\bin\gem                       #(for Windows)"
   exit 1
end
@gem_cmd = ENV['GEM_COMMAND']

dev_gem_sources = ['int-ububld1', 'int-ububld1.f4tech.com']
dev_gem_sources.each do |dgs|
  begin
    run_command("gem sources --remove http://#{dgs}:9292/")
  rescue => ex
  end
end

def main(args)

  # Allow an optional proxy parameter
  if args.length > 2
    puts "USAGE: install.rb [proxy]"
    exit 1
  end

  proxy = ""
  if args.length == 2
    proxy = "-p #{args[1]}"
  end

  Dir.chdir('gems') do

    for gem, version in BASE_GEMS do
       gem_installer = "#{@gem_cmd} install #{gem} -v #{version} #{proxy} --no-ri --no-rdoc"
       status = run_command(gem_installer)
       if status.exited?
         puts "  ... #{gem} installed"
       end
    end

    for gem in CORE_GEMS + PROD_GEMS do
      hits = Dir.entries(".").grep(/^#{gem}-.*\.gem/)
      if hits.length == 1
        installable_gem = hits.first
        #puts "               installing gem: #{installable_gem}"
        $stdout.flush
        gem_installer = "#{@gem_cmd} install --local #{installable_gem} --no-ri --no-rdoc"
        #puts gem_installer
        #$stdout.flush
        status = run_command(gem_installer)
        if status.exited?
          puts "  ... #{gem} installed"
          $stdout.flush
        else
          $stderr.write("  ... FAILED to install #{installable_gem}\n")
        end
      end
    end
  end

end


def run_command(command)
  require 'open3'

  command_output = ""
  #puts command
  i,o,e,t = Open3.popen3(command)

  command_output, command_error = [o.read, e.read]
  puts command_error if !command_error.nil? && !command_error.empty?

  i.close && o.close && e.close
  command_exit_status = t.value
  return command_exit_status
end


main(ARGV)

